﻿/*
 This file is part of ELoadV1.

    ELoadV1 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    ELoadV1 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ELoadV1.  If not, see <http://www.gnu.org/licenses/>.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ELoadV1
{
    class DataLogger
    {
        public DataLogger()
        {
            file_data = "";
            line_cnt = 0;
        }
        public void Clear()
        {
            file_data = "";
            line_cnt = 0;
        }
        public void AppendToLog(float set_val, string mode, float act_curr, float act_volt, float act_power, float act_res, float temperature)
        {
            if (line_cnt == 0)
            {
                file_data = "Logfile <" + DateTime.Now.ToShortDateString() + " - " + DateTime.Now.ToShortTimeString() + ">" + Environment.NewLine;
                file_data += "Units: Time in s, Current in A, Voltage in V, Power in W, Resistance in Ohms, Temp. in degC" + Environment.NewLine;
                file_data += "Mode\t" + "Time\t" + "Setvalue\t" + "Current\t" + "Voltage\t" + "Power\t" + "Resistance\t" + "Temp" + Environment.NewLine;
                t0 = DateTime.Now;
            }
            t = DateTime.Now - t0;
            file_data += mode + "\t" + t.TotalSeconds.ToString()  + "\t" + set_val.ToString() + "\t" + 
                act_curr.ToString() + "\t" + act_volt.ToString() + "\t" + act_power.ToString() + "\t" + 
                act_res.ToString() + "\t"  + temperature.ToString() + Environment.NewLine;
            line_cnt++;
        }
        public void WriteLogFile(string path)
        {
            System.IO.File.WriteAllText(path, file_data);
        }
        public long GetMeasLines()
        {
            return line_cnt;
        }

        private string file_data;
        private long line_cnt;
        DateTime t0;
        TimeSpan t;
    }
}
